import {
  select,
  json,
  tsv,
  geoPath,
  geoNaturalEarth1,
  zoom,
  event
} from 'd3';
import { feature } from 'topojson';

const svg = select('svg');

const projection = geoNaturalEarth1();
const pathGenerator = geoPath().projection(projection);

const g = svg.append('g');

g.append('path')
    .attr('class', 'sphere')
    .attr('d', pathGenerator({type: 'Sphere'}));

Promise.all([
  tsv('https://unpkg.com/world-atlas@1.1.4/world/50m.tsv'),
  json('https://unpkg.com/world-atlas@1.1.4/world/50m.json')
]).then(([tsvData, topoJSONdata]) => {
  
  console.log(topoJSONdata)
  
  const countryName = tsvData.reduce((accumulator, d) => {
    accumulator[d.iso_n3] = d.name;
    return accumulator;
  }, {});
  
  var country = ['India','Brazil','Canada'];
  
  var link_news = {'India':'https://riotimesonline.com/?s=india+news','Canada':'https://riotimesonline.com/?s=canada+news','Brazil':'https://riotimesonline.com/?s=brazil+news'};
  
  console.log(link_news.hasOwnProperty('India'))
  
  const countries = feature(topoJSONdata, topoJSONdata.objects.countries);
  
  console.log('dataset',countries)
  
  g.selectAll('path').data(countries.features)
    .enter()
  .append('a')
     .attr('href',d => link_news.hasOwnProperty(countryName[d.id])? link_news[countryName[d.id]] : '#'  )
     .attr('class', d => link_news.hasOwnProperty(countryName[d.id])? 'enable':
           'disabled' )
    .append('path')
      .attr('class', d => country.includes(countryName[d.id]) ?    'nocountry':'country')
      .attr('d', d => {return pathGenerator(d)})
    .append('title')
      .text(d =>  country.includes(countryName[d.id]) ?  countryName[d.id]:    countryName[d.id] + ' is news not available ')
      
    
});